<template>
  <v-form>
    <v-container fluid>
      <v-row dense>
        <v-col cols="12">
          <v-text-field
            v-model="email"
            type="email"
            :label="$t('email')"
            outlined
            required
            hide-details
          />
        </v-col>
        <v-col cols="12">
          <v-text-field
            v-mask="'+# (###) ### ##-##'"
            v-model="phone"
            type="phone"
            :label="$t('phone')"
            outlined
            required
            hide-details
          />
        </v-col>

        <v-col cols="12">
          <v-btn block large color="primary" @click="signUp">{{
            $t('button.text')
          }}</v-btn>
        </v-col>

        <v-col cols="12">
          <p class="font-weight-light">
            Нажимая "{{ $t('button.text') }}" я принимаю
            <a
              href="https://app.ledius.ru/public/static-content/docs/ru/terms_of_use.pdf"
              target="_blank"
              >условия пользовательского соглашения</a
            >
            ,
            <a
              href="https://app.ledius.ru/public/static-content/docs/ru/privacy.pdf"
              target="_blank"
              >политику в отношении обработки персональных данных</a
            >,
            <a
              href="https://app.ledius.ru/public/static-content/docs/ru/offer.pdf"
              target="_blank"
              >договор оферты</a
            >
          </p>
        </v-col>
      </v-row>
    </v-container>
  </v-form>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { JoinForm } from '@/domain/form/join/JoinForm';

@Component({})
export default class SignUpForm extends Vue {
  private email: string = '';
  private phone: string = '';
  private agreed: boolean = false;

  private get unmaskedPhone(): string {
    return this.phone
      .split('')
      .map(char => char.trim())
      .filter(char => Number.isInteger(Number(char)))
      .join('');
  }

  private async signUp(): Promise<void> {
    await this.$store.dispatch(
      'auth/join',
      new JoinForm(this.email, this.unmaskedPhone)
    );
    await this.$router.push({
      name: 'Login',
      query: {
        email: this.email
      }
    });
  }

  private async agree(): Promise<void> {
    this.agreed = true;
  }
}
</script>

<style scoped></style>

<i18n>
{
  "ru": {
    "button": {
      "text": "Присоединиться"
    },
    "email": "Email",
    "phone": "Телефон"
  }
}
</i18n>
